import org.jetbrains.kotlin.gradle.dsl.KotlinVersion
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.configureAllCompilersOptions
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.defineAllMultiplatformTargets
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.defineXomrkGiteaMavenRepo
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.optInContracts
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.plugin.xomrk
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.setCompatibilityWithKotlin
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.warningsAsErrors

buildscript {
	repositories {
		mavenCentral()
		maven("https://maven.landgrafhomyak.ru/")
	}

	dependencies {
		classpath("ru.landgrafhomyak.kotlin:kotlin-mpp-gradle-build:v0.2k2.0.20")
	}
}

group = "ru.landgrafhomyak.db.sql_skeleton"
version = "0.0"

repositories {
	mavenCentral()
	maven("https://maven.landgrafhomyak.ru/")
}

xomrk {
	kotlin {
		explicitApi()
		warningsAsErrors()
		optInContracts()
		setCompatibilityWithKotlin(KotlinVersion.KOTLIN_1_7)
		configureAllCompilersOptions { freeCompilerArgs.add("-Xjvm-default=all") }

		jvmToolchain(8)
		defineAllMultiplatformTargets()


		sourceSets {
			commonMain {
				dependencies {
					compileOnly("org.jetbrains.kotlinx:kotlinx-coroutines-core:1.10.2")
				}
			}
		}
	}

	publishing {
		repositories {
			defineXomrkGiteaMavenRepo(user="SqlSkeleton")
		}
	}
}