package ru.landgrafhomyak.db.skeleton1.api.errors.definition

import kotlin.jvm.JvmStatic
import kotlinx.coroutines.CopyableThrowable
import kotlinx.coroutines.ExperimentalCoroutinesApi
import ru.landgrafhomyak.db.skeleton1.api.DebugApi
import ru.landgrafhomyak.db.skeleton1.api.DriverMetainfo
import ru.landgrafhomyak.db.skeleton1.api.errors.SchemaDefinitionException

@DebugApi
public abstract class UnboundParameterException : SchemaDefinitionException {
	public val constructor: Any

	public constructor(constructor: Any) : super() {
		this.constructor = constructor
	}

	public constructor(constructor: Any, customMessage: String) : super(customMessage) {
		this.constructor = constructor
	}

	public constructor(constructor: Any, customMessage: String, cause: Throwable) : super(customMessage, cause) {
		this.constructor = constructor
	}

	public constructor(constructor: Any, cause: Throwable) : super(cause) {
		this.constructor = constructor
	}

	public constructor(
		constructor: Any,
		message: String?, cause: Throwable?,
		@Suppress("unused", "LocalVariableName") _marker: Unit
	) : super(message, cause, _marker) {
		this.constructor = constructor
	}

}