package ru.landgrafhomyak.db.skeleton1.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.ObjectOperations
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.table.Table
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow


public interface ModuleConstructorScope<mUE : Any, IK : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("rootNs")
	public val rootNs: Namespace<mUE, IK>

	public fun <tUE : Any> createTable(
		lifeTime: Table.LifeTime = Table.LifeTime.DATABASE_SCOPE,
		namespace: Namespace<mUE, IK> = this.rootNs,
		name: String, initializer: Table.Constructor<tUE, IK>
	): Table<tUE, mUE, IK>

	public fun <oUE : Any?> moduleScopedObject(
		namespace: Namespace<mUE, IK> = this.rootNs,
		name: String, metadata: ObjectOperations.ImplementationsProvider<oUE>
	): ModuleScopedObject<oUE, mUE, IK>

	public fun <mUE : Any> substituteModule(rootNs: Namespace<mUE, IK>, template: Module.Template<mUE>): Module<mUE, IK>

	public fun namespace(parent: Namespace<mUE, IK>, name: String): Namespace<mUE, IK>

	public fun addStatement(stmt: _Statement.Void2Void<*, IK>)
	public fun addStatement(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addStatement(stmt: _Statement.Params2Void<sUE, IK>): InputRow._Scope<sUE, IK, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addStatement(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, IK, Unit>
}