package ru.landgrafhomyak.db.skeleton1.api.runtime

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.statement.InputParam

public interface InputRow<qUE : Any, IK : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: qUE

	public operator fun <RuntimeType> set(c: InputParam<RuntimeType, qUE, IK>, value: RuntimeType)

	public operator fun set(c: InputParam<Byte, qUE, IK>, value: Byte): Unit = this.set<Byte>(c, value)
	public operator fun set(c: InputParam<UByte, qUE, IK>, value: UByte): Unit = this.set<UByte>(c, value)
	public operator fun set(c: InputParam<Short, qUE, IK>, value: Short): Unit = this.set<Short>(c, value)
	public operator fun set(c: InputParam<UShort, qUE, IK>, value: UShort): Unit = this.set<UShort>(c, value)
	public operator fun set(c: InputParam<Int, qUE, IK>, value: Int): Unit = this.set<Int>(c, value)
	public operator fun set(c: InputParam<UInt, qUE, IK>, value: UInt): Unit = this.set<UInt>(c, value)
	public operator fun set(c: InputParam<Long, qUE, IK>, value: Long): Unit = this.set<Long>(c, value)
	public operator fun set(c: InputParam<ULong, qUE, IK>, value: ULong): Unit = this.set<ULong>(c, value)
	public operator fun set(c: InputParam<Char, qUE, IK>, value: Char): Unit = this.set<Char>(c, value)
	public operator fun set(c: InputParam<Boolean, qUE, IK>, value: Boolean): Unit = this.set<Boolean>(c, value)

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Scope<qUE : Any, RK : Any, out Next> : InputRow<qUE, RK> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _finish(): Next

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _abort()
	}

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Iterator<qUE : Any, RK : Any, out Next> : _Scope<qUE, RK, Next>, InputRow<qUE, RK> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _next(): Boolean

		@Suppress("FunctionName")
		@LowLevelApi
		public override suspend fun _abort()

		@Suppress("FunctionName")
		@LowLevelApi
		public override suspend fun _finish(): Next
	}
}