package ru.landgrafhomyak.db.skeleton1.api.runtime

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.statement.OutputColumn

public interface OutputRow<qUE : Any, IK : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: qUE

	public operator fun <RuntimeType> get(c: OutputColumn<RuntimeType, qUE, IK>): RuntimeType

	public operator fun get(c: OutputColumn<Byte, qUE, IK>): Byte = this.get<Byte>(c)
	public operator fun get(c: OutputColumn<UByte, qUE, IK>): UByte = this.get<UByte>(c)
	public operator fun get(c: OutputColumn<Short, qUE, IK>): Short = this.get<Short>(c)
	public operator fun get(c: OutputColumn<UShort, qUE, IK>): UShort = this.get<UShort>(c)
	public operator fun get(c: OutputColumn<Int, qUE, IK>): Int = this.get<Int>(c)
	public operator fun get(c: OutputColumn<UInt, qUE, IK>): UInt = this.get<UInt>(c)
	public operator fun get(c: OutputColumn<Long, qUE, IK>): Long = this.get<Long>(c)
	public operator fun get(c: OutputColumn<ULong, qUE, IK>): ULong = this.get<ULong>(c)
	public operator fun get(c: OutputColumn<Char, qUE, IK>): Char = this.get<Char>(c)
	public operator fun get(c: OutputColumn<Boolean, qUE, IK>): Boolean = this.get<Boolean>(c)

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Scope<qUE : Any, RK : Any, out Next> : OutputRow<qUE, RK> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _finish(): Next

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _abort()
	}

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Iterator<qUE : Any, RK : Any, out Next> : _Scope<qUE, RK, Next>, OutputRow<qUE, RK> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _next(): Boolean

		@Suppress("FunctionName")
		@LowLevelApi
		public override suspend fun _abort()

		@Suppress("FunctionName")
		@LowLevelApi
		public override suspend fun _finish(): Next
	}
}