package ru.landgrafhomyak.db.skeleton1.api.statement

import ru.landgrafhomyak.db.skeleton1.api.DriverMetainfo

public interface RawStatement<sUE : Any?, IK : Any> : _Statement<sUE, IK> {
	public override val uExt: sUE

	public interface Void2Void<sUE : Any?, IK : Any> : RawStatement<sUE, IK>, _Statement.Void2Void<sUE, IK> {
		override val uExt: sUE

		public interface Constructor<@Suppress("unused") sUE : Any?>

		public interface ImplementationsProvider<USER_EXTENSION : Any?> {
			public fun provideStatementImplementations_void2void(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any?> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverMetainfo: DriverMetainfo<*, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Void2Row<sUE : Any, IK : Any> : RawStatement<sUE, IK>, _Statement.Void2Row<sUE, IK> {
		override val uExt: sUE

		public interface Constructor<@Suppress("unused") sUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_void2row(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverMetainfo: DriverMetainfo<*, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Void2RowOrNull<sUE : Any, IK : Any> : RawStatement<sUE, IK>, _Statement.Void2RowOrNull<sUE, IK> {
		override val uExt: sUE

		public interface Constructor<@Suppress("unused") sUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_void2rowOrNull(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverMetainfo: DriverMetainfo<*, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}

	}

	public interface Void2Table<sUE : Any, IK : Any> : RawStatement<sUE, IK>, _Statement.Void2Table<sUE, IK> {
		override val uExt: sUE

		public interface Constructor<@Suppress("unused") sUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_void2table(selector: Selector<USER_EXTENSION>)

			public interface Selector<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverMetainfo: DriverMetainfo<*, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2Void<sUE : Any, IK : Any> : RawStatement<sUE, IK>, _Statement.Params2Void<sUE, IK> {
		override val uExt: sUE

		public interface Constructor<@Suppress("unused") sUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2void(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverMetainfo: DriverMetainfo<*, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2Row<sUE : Any, IK : Any> : RawStatement<sUE, IK>, _Statement.Params2Row<sUE, IK> {
		override val uExt: sUE

		public interface Constructor<@Suppress("unused") sUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2row(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverMetainfo: DriverMetainfo<*, *, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2RowOrNull<sUE : Any, IK : Any> : RawStatement<sUE, IK>, _Statement.Params2RowOrNull<sUE, IK> {
		override val uExt: sUE

		public interface Constructor<@Suppress("unused") sUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2rowOrNull(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverMetainfo: DriverMetainfo<*, *, *, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2Table<sUE : Any, IK : Any> : RawStatement<sUE, IK>, _Statement.Params2Table<sUE, IK> {
		override val uExt: sUE

		public interface Constructor<@Suppress("unused") sUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2table(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverMetainfo: DriverMetainfo<*, *, *, *, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}
}