package ru.landgrafhomyak.db.skeleton1.api.table

import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow

public interface TableUpgradeScope<tnUE : Any, toUE : Any, IK : Any> : TableConstructorScope<tnUE, IK> {
	public fun <RT> keepColumn(c: Column<RT, toUE, IK>): Column<RT, tnUE, IK>
	public fun <RT> renameColumn(c: Column<RT, toUE, IK>, newName: String): Column<RT, tnUE, IK>
	public fun deleteColumn(c: Column<*, toUE, IK>)
	public fun <RT> deleteColumnAfterUpgrade(c: Column<RT, toUE, IK>): Column<RT, tnUE, IK>

	public fun <RT> keepColumnWithBoundType(c: Column<RT, toUE, IK>): Column<RT, tnUE, IK>
	public fun <RT> unbindAndKeepColumnWithBoundType(c: Column<RT, toUE, IK>): Column<RT, tnUE, IK>
	public fun <RT> renameColumnWithBoundType(c: Column<RT, toUE, IK>, newName: String): Column<RT, tnUE, IK>
	public fun <RT> unbindAndRenameColumnWithBoundType(c: Column<RT, toUE, IK>, newName: String): Column<RT, tnUE, IK>
	public fun deleteColumnWithBoundType(c: Column<*, toUE, IK>)
	public fun <RT> deleteColumnWithBoundTypeAfterUpgrade(c: Column<RT, toUE, IK>): Column<RT, tnUE, IK>

	public fun <oUE : Any?> keepTableScopedObject(obj: TableScopedObject<oUE, toUE, IK>): TableScopedObject<oUE, tnUE, IK>
	public fun <oUE : Any?> renameTableScopedObject(obj: TableScopedObject<oUE, toUE, IK>, newName: String): TableScopedObject<oUE, tnUE, IK>
	public fun <oUE : Any?> deleteTableScopedObject(obj: TableScopedObject<oUE, toUE, IK>): TableScopedObject<oUE, tnUE, IK>

	public fun addAlterStatementAfterUpgrade(stmt: _Statement.Void2Void<*, IK>)
	public fun addAlterStatementAfterUpgrade(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatementAfterUpgrade(stmt: _Statement.Params2Void<sUE, IK>): InputRow._Scope<sUE, IK, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatementAfterUpgrade(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, IK, Unit>
}